package de.isse.kiv.refactoring

import org.eclipse.jface.text.IDocument
import org.eclipse.ltk.core.refactoring.DocumentChange
import org.eclipse.text.edits.MultiTextEdit
import org.eclipse.text.edits.InsertEdit
import kiv.parser._

class InsertTextChange(document: IDocument, insertMarker: Location, extractName: String, extractedContent: String)
  extends DocumentChange("Insert: " + extractName, document) {
  val multiTextEdit = new MultiTextEdit
  multiTextEdit.addChild(new InsertEdit(insertMarker.position, extractedContent));
  setEdit(multiTextEdit)
}
