package de.isse.kiv.refactoring

import org.eclipse.jface.text.IDocument
import org.eclipse.ltk.core.refactoring.DocumentChange
import org.eclipse.text.edits.MultiTextEdit
import org.eclipse.text.edits.ReplaceEdit
import kiv.parser._
import de.isse.kiv.source.parser.KIVToken

/**
 * This class represents the change made to the document
 * The class CodeRenameRefactoring constructs a change object in the createChange() method
 */
class RenameTextChange(val document: IDocument, locationList: List[Location], kivToken: KIVToken, editedString: String)
  extends DocumentChange("Rename: " + kivToken.stringPresentation, document) {

  val multiTextEdit = new MultiTextEdit
  locationList.foreach(loc => multiTextEdit.addChild(new ReplaceEdit(loc.position, loc.length, editedString)))
  setEdit(multiTextEdit)

  def addEdits(locationList: List[Location], editedString: String) {
    locationList.foreach(loc => multiTextEdit.addChild(new ReplaceEdit(loc.position, loc.length, editedString)))
  }
}
