package de.isse.kiv.refactoring

import org.eclipse.jface.text.IDocument
import org.eclipse.ltk.core.refactoring.DocumentChange
import org.eclipse.text.edits.MultiTextEdit
import org.eclipse.text.edits.ReplaceEdit
import kiv.parser._

class ReplaceTextChange(document: IDocument, locationToReplace: Location, extractName: String, replaceContent: String)
  extends DocumentChange("Insert: " + extractName, document) {
  val multiTextEdit = new MultiTextEdit
  multiTextEdit.addChild(new ReplaceEdit(locationToReplace.position, locationToReplace.length, replaceContent));
  setEdit(multiTextEdit)
}
