package de.isse.kiv.ui

import org.eclipse.jface.dialogs.MessageDialog
import org.eclipse.ui.PlatformUI
import org.eclipse.swt.widgets.Display
import java.util.concurrent.FutureTask
import java.util.concurrent.Callable

object MessageWindow {
  def showMessage_OK(title: String, message: String) {
    Display.getDefault.syncExec(new Runnable() {
      override def run() {
        val shell = PlatformUI.getWorkbench.getModalDialogShellProvider.getShell
        val dialog = new MessageDialog(shell, title, null, message, MessageDialog.ERROR, Array("OK"), 0)
        dialog.open()
      }
    })
  }

  def showMessage_YES_NO(title: String, message: String): Int = {
    val future = new FutureTask(new Callable[Int]() {
      override def call(): Int = {
        val shell = PlatformUI.getWorkbench.getModalDialogShellProvider.getShell
        val dialog = new MessageDialog(shell, title, null, message, MessageDialog.QUESTION, Array("No", "Yes"), 0)
        dialog.open()
      }
    })
    Display.getDefault.syncExec(future)
    future.get
  }
}
