package de.isse.kiv.ui.editors

import org.eclipse.core.resources.IMarker
import org.eclipse.core.runtime.CoreException
import org.eclipse.jface.text.IDocument
import org.eclipse.jface.text.Position
import org.eclipse.ui.texteditor.IMarkerUpdater
import de.isse.kiv.resources.Marker

class MarkerUpdater extends IMarkerUpdater {

  override def getAttribute(): Array[String] = null

  override def getMarkerType(): String = Marker.ERROR_MARKER_ID

  override def updateMarker(marker: IMarker, doc: IDocument, position: Position): Boolean = {
    try {
      val start = position.getOffset
      val end = position.getOffset + position.getLength
      marker.setAttribute(IMarker.CHAR_START, start)
      marker.setAttribute(IMarker.CHAR_END, end)
      true
    } catch {
      case e: CoreException => false
    }
  }
}
