package de.isse.kiv.ui.handlers

import scala.Array.canBuildFrom

import org.eclipse.core.commands.AbstractHandler
import org.eclipse.core.commands.ExecutionEvent
import org.eclipse.core.resources.IProject
import org.eclipse.jface.viewers.IStructuredSelection
import org.eclipse.ltk.ui.refactoring.RefactoringWizardOpenOperation
import org.eclipse.ltk.ui.refactoring.resource.DeleteResourcesWizard
import org.eclipse.swt.widgets.Display
import org.eclipse.ui.PlatformUI

class DeleteHandler extends AbstractHandler {

  override def execute(event: ExecutionEvent): AnyRef = {
    if (event.getCommand.getId.toString == "de.isse.kiv.ui.commands.delete") {
      val iwPage = PlatformUI.getWorkbench.getActiveWorkbenchWindow.getActivePage
      val selection = iwPage.getSelection
      val activeShell = PlatformUI.getWorkbench.getActiveWorkbenchWindow.getShell
      if (selection == null) return null
      
      iwPage.getSelection match {
        case selection: IStructuredSelection =>

        val drw = new DeleteResourcesWizard(selection.toArray.collect { case p: IProject => p } )
        val op = new RefactoringWizardOpenOperation(drw)
        try {
          op.run(Display.getCurrent.getActiveShell, "Delete Resource")
        } catch {
          case e: InterruptedException => 
        }
      }
    }
    null
  }
}
