package de.isse.kiv.ui.handlers

import org.eclipse.core.commands.AbstractHandler
import org.eclipse.core.commands.ExecutionEvent
import org.eclipse.core.commands.ExecutionException
import org.eclipse.core.resources.IFile
import org.eclipse.core.runtime.Path
import org.eclipse.ui.IEditorDescriptor
import org.eclipse.ui.IWorkbenchPage
import org.eclipse.ui.PartInitException
import org.eclipse.ui.PlatformUI
import org.eclipse.ui.part.FileEditorInput
import de.isse.kiv.resources.ResourceLookup
import de.isse.kiv.ui.Console

class EditorToggleHandler extends AbstractHandler {

  override def execute(event: ExecutionEvent): AnyRef = {
    val file = ResourceLookup.documentResource
    if (file == null) return null
    
    val name = file.getName match {
      case "sequents.utf8" =>  "specification.utf8"
      case "specification.utf8" =>  "sequents.utf8"
    }
    
    val toOpen = file.getParent.getFile(new Path(name))

    if (!toOpen.exists()) return null

    val desc = PlatformUI.getWorkbench.getEditorRegistry.getDefaultEditor(file.getName)
    val page = ResourceLookup.activePage

    page.openEditor(new FileEditorInput(toOpen), desc.getId)

    null
  }
}
