package de.isse.kiv.ui.handlers

import org.eclipse.core.commands.AbstractHandler
import org.eclipse.core.commands.ExecutionEvent
import org.eclipse.core.commands.ExecutionException
import org.eclipse.core.resources.IResource
import org.eclipse.jface.viewers.ISelection
import org.eclipse.jface.viewers.IStructuredSelection
import org.eclipse.ui.IWorkbenchPage
import org.eclipse.ui.PlatformUI
import de.isse.kiv.ui.Console
import org.eclipse.core.runtime.Path
import de.isse.kiv.resources.ResourceLookup
import org.eclipse.ui.part.FileEditorInput
import de.isse.kiv.ui.editors.FileEditor.openFile
import org.eclipse.core.resources.IFolder

class OpenHandler extends AbstractHandler {

  override def execute(event: ExecutionEvent): AnyRef = {

    val command = event.getCommand.getId.toString
    val fileName = command match {
      case "de.isse.kiv.ui.commands.open_formulas" => Some("formulas.utf8")
      case "de.isse.kiv.ui.commands.open_patterns" => Some("patterns.utf8")
      case _ => None
    }

    for (name <- fileName) {
      val iwPage = PlatformUI.getWorkbench.getActiveWorkbenchWindow.getActivePage
      val selection = iwPage.getSelection

      if (selection != null && selection.isInstanceOf[IStructuredSelection]) {
        val selectedFileSelection = selection.asInstanceOf[IStructuredSelection]
        val obj = selectedFileSelection.getFirstElement
        val selectedFile = obj.asInstanceOf[IResource]

        val fileToOpen = selectedFile.getParent.asInstanceOf[IFolder].getFile(name)
        val project = selectedFile.getProject

        if (!fileToOpen.exists()) return null

        openFile(fileToOpen)

      }

    }

    null
  }
}
