package de.isse.kiv.ui.outline

import org.eclipse.jface.viewers.LabelProvider
import de.isse.kiv.resources.FileModel.RegionString
import kiv.spec.Theorem
import kiv.prog.Anydeclaration
import kiv.parser.PreOperationDeclaration

class FileOutlineLabelProvider extends LabelProvider {
  override def getText(element: AnyRef): String = element match {
    case theorem: Theorem =>
      theorem.theoremname
    case decl: Anydeclaration =>
      decl.declprocdecl.proc.procsym.name
    case predecl: PreOperationDeclaration =>
      predecl.nameandloc.str
    case _ =>
      element.toString
  }
}
