package de.isse.kiv.ui.wizards

import org.eclipse.core.runtime.NullProgressMonitor
import org.eclipse.ltk.core.refactoring.Refactoring
import org.eclipse.ltk.ui.refactoring.RefactoringWizard

import de.isse.kiv.refactoring.CodeExtractRefactoring

class ExtractRefactoringWizard(refactoring: Refactoring) extends RefactoringWizard(refactoring, RefactoringWizard.DIALOG_BASED_USER_INTERFACE | RefactoringWizard.CHECK_INITIAL_CONDITIONS_ON_OPEN) {

  def addUserInputPages() {
    val extract = refactoring.asInstanceOf[CodeExtractRefactoring]
    this.addPage(new ExtractRefactoringWizardPage(extract.extracttype, "Extract", this))
  }

  override def performFinish(): Boolean = {
    if (refactoring.asInstanceOf[CodeExtractRefactoring].extracttype == 3) return false; // No Expression or Programm found, refactoring not useful
    val change = refactoring.createChange(new NullProgressMonitor)
    change.perform(new NullProgressMonitor)
    true
  }
}
