package de.isse.kiv.ui.wizards

import java.lang.reflect.InvocationTargetException
import org.eclipse.core.runtime.CoreException
import org.eclipse.core.runtime.IPath
import org.eclipse.core.runtime.IProgressMonitor
import org.eclipse.jface.operation.IRunnableWithProgress
import org.eclipse.jface.viewers.IStructuredSelection
import org.eclipse.ui.IWorkbench

class ImportProjectWizard extends KIVProjectWizard() {

  protected var page: ImportProjectWizardPage = _
  var path: Option[String] = None
  setNeedsProgressMonitor(true)

  override def addPages() {
    page = new ImportProjectWizardPage(path)
    addPage(page)
  }

  def setPath(p:String){
    path = Some(p)
  }

  override def init(workbench: IWorkbench, selection: IStructuredSelection) {
  }

  class CreateProjectWithProgress(private val locations: Array[IPath]) extends IRunnableWithProgress {

    def run(monitor: IProgressMonitor) {
      monitor.beginTask("Importing " + locations.length + " projects.", locations.length)
      for (i <- 0 until locations.length) {
        create(locations(i), monitor)
        monitor.worked(1)
      }
      monitor.done()
    }

    def create(location: IPath, monitor: IProgressMonitor) {
      try {
        val name = location.lastSegment()
        val comment: String = null
        createProject(name, comment, location, null)
      } catch {
        case e: CoreException => 
      }
    }
  }

  override def performFinish(): Boolean = {
    val locations = page.getProjects
    try {
      getContainer.run(true, false, new CreateProjectWithProgress(locations))
    } catch {
      case e: InvocationTargetException => 
      case e: InterruptedException => 
    } finally {
      page.dispose()
    }
    updatePerspective()
    true
  }
}
